#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>
#include <string.h>
#include <errno.h>

void usage() {
    fprintf(stderr, "usage: -[r|w|x|v] file\n");
}

int main(int argc, char **argv) {
  int mode = 0;
  int verbose = 0;
  int i = 0;

  if (argc != 3) { usage(); exit(1); }

  if ( argv[1][i] != '-' ) { usage(); exit(1); }

  for(i=1; argv[1][i]; i++) {
    switch (argv[1][i]) {
    case 'r' : 
      mode = mode | R_OK;
      break;
    case 'w' :
      mode = mode | W_OK;
      break;
    case 'x' :
      mode = mode | X_OK;
      break;
    case 'v' :
      verbose = 1;
      break;
    default : 
      usage(); 
      exit(1);
    }
  }


  if ( access(argv[2], mode) == -1) {
    if (verbose) {
      switch (errno) {
      case EACCES :
	fprintf(stderr, "les droits demandes ne sont pas positionnes\n");
	break;
      case ENOENT :
	fprintf(stderr, "%s: le fichier n'existe pas\n", argv[2]);
	break;
      case ENOTDIR :
	fprintf(stderr, "%s: une partie du nom n'est pas un repertoire\n", 
		argv[2]);
	break;
      case ENAMETOOLONG :
	fprintf(stderr, "%s: le nom  est trop long\n", argv[2]);
	break;
      case ELOOP :
	fprintf(stderr, "trop de liens symboliques\n");
	break;
      default :
	perror("access");
	break;
      }
    }
    exit(1);
  }
  exit(0);

}
